# $Revision: 1.57 $, $Date: 2010/04/06 11:24:56 $
Summary:	A periodical command scheduler which aims at replacing Vixie Cron
Summary(pl.UTF-8):	Serwer okresowego uruchamiania poleceń zastępujący Vixie Crona
Name:		fcron
Version:	3.0.6
Release:	1
License:	GPL v2+
Group:		Daemons
Source0:	http://fcron.free.fr/archives/%{name}-%{version}.src.tar.gz
# Source0-md5:	69ebcb41921e2a282f41ebecb3a27053
Source1:	%{name}.init
Source2:	cron.logrotate
Source3:	cron.sysconfig
Source4:	%{name}.crontab
Source5:	%{name}.pam
Source6:	%{name}.conf
Source7:	%{name}tab.pam
Source8:	%{name}.systab
Patch0:		%{name}-configure.patch
Patch1:		%{name}-Makefile.patch
Patch2:		%{name}-accept_readable_fcron.conf.patch
URL:		http://fcron.free.fr/
# configure tests -x (check can be removed, just like sendmail)
BuildRequires:	/bin/vi
BuildRequires:	autoconf
BuildRequires:	automake
BuildRequires:	libselinux-devel
BuildRequires:	pam-devel
BuildRequires:	rpmbuild(macros) >= 1.268
Requires(post):	fileutils
Requires(post,preun):	/sbin/chkconfig
Requires(postun):	/usr/sbin/groupdel
Requires(pre):	/bin/id
Requires(pre):	/usr/bin/getgid
Requires(pre):	/usr/sbin/groupadd
Requires(pre):	/usr/sbin/useradd
Requires:	/bin/run-parts
Requires:	psmisc >= 20.1
Requires:	rc-scripts
Provides:	crondaemon
Provides:	crontabs = 1.7
Provides:	group(crontab)
Obsoletes:	crondaemon
Obsoletes:	crontabs
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%description
Fcron is a periodical command scheduler which aims at replacing Vixie
Cron, so it implements most of its functionalities. But fcron does not
assume that your system is running neither all the time nor regularly:
you can, for instance, tell fcron to execute tasks every x hours y
minutes of system up time or to do a job only once in a specified
interval of time. You can also set a nice value to a job, run it
depending on the system load average and much more !

%description -l pl.UTF-8
Fcron jest serwerem okresowego uruchamiania poleceń mającym za cel
zastąpienie Vixie Crona, posiadającym zaimplementowane większość
spośród jego funkcji. Jednakże fcron nie zakłada, że system działa
cały czas, ani że jest uruchamiany regularnie: można, na przykład,
kazać fcronowi uruchamiać zadanie co każde x godzin y minut od
uruchomienia systemu lub wykonywać zadanie dokładnie raz w podanym
okresie czasu. Umożliwia również ustawianie wartości nice dla zadania,
uruchamianie go w zależności od obciążenia systemu i dużo więcej.

%prep
%setup -q
%patch0 -p1
%patch1 -p1
%patch2 -p0

%build
%{__aclocal}
%{__autoconf}
%configure \
	--with-sendmail=/usr/sbin/sendmail \
	--with-sysfcrontab=systab \
	--with-spooldir=%{_var}/spool/cron \
	--with-run-non-privileged=no \
	--with-boot-install=no \
	--with-fcrondyn=yes \
	--with-username=crontab \
	--with-groupname=crontab \
	--with-pam=yes \
	--with-selinux=yes \
	--with-boot-install=no \
	--with-editor=/bin/vi

%{__make} \
	OPTION="%{rpmcflags}"

echo "#!/bin/sh" > script/user-group

%install
rm -rf $RPM_BUILD_ROOT
install -d $RPM_BUILD_ROOT{/var/{log,spool/cron},%{_mandir}} \
	$RPM_BUILD_ROOT/etc/{rc.d/init.d,logrotate.d,sysconfig} \
	$RPM_BUILD_ROOT%{_sysconfdir}/{cron,cron.{d,hourly,daily,weekly,monthly},pam.d}

%{__make} install-staged \
	DESTDIR=$RPM_BUILD_ROOT \
	ROOTNAME=$(id -u) \
	ROOTGROUP=$(id -g) \
	USERNAME=$(id -u) \
	GROUPNAME=$(id -g)

#fix premission for rpmbuild
chmod +rw $RPM_BUILD_ROOT%{_prefix}/*bin/*

ln -sf %{_bindir}/fcrontab $RPM_BUILD_ROOT%{_bindir}/crontab
mv -f $RPM_BUILD_ROOT%{_sbindir}/fcron $RPM_BUILD_ROOT%{_sbindir}/crond

install %{SOURCE1} $RPM_BUILD_ROOT/etc/rc.d/init.d/crond
install %{SOURCE2} $RPM_BUILD_ROOT/etc/logrotate.d/cron
install %{SOURCE3} $RPM_BUILD_ROOT/etc/sysconfig/cron
install %{SOURCE4} $RPM_BUILD_ROOT/etc/cron.d/crontab
install %{SOURCE5} $RPM_BUILD_ROOT/etc/pam.d/fcron
install %{SOURCE6} $RPM_BUILD_ROOT%{_sysconfdir}/fcron.conf
install %{SOURCE7} $RPM_BUILD_ROOT/etc/pam.d/fcrontab
install %{SOURCE8} $RPM_BUILD_ROOT/etc/cron.hourly/fcron.systab

touch $RPM_BUILD_ROOT/var/log/cron

cat > $RPM_BUILD_ROOT%{_sysconfdir}/cron/cron.allow << 'EOF'
# cron.allow	This file describes the names of the users which are
#		allowed to use the local cron daemon
root
EOF

cat > $RPM_BUILD_ROOT%{_sysconfdir}/cron/cron.deny << 'EOF'
# cron.deny	This file describes the names of the users which are
#		NOT allowed to use the local cron daemon
EOF

%clean
rm -rf $RPM_BUILD_ROOT

%pre
%groupadd -g 117 -r -f crontab
%useradd -u 134 -r -d /var/spool/cron -s /bin/false -c "crontab User" -g crontab crontab

%post
if [ "$1" = "1" ]; then
	if [ -d /var/spool/cron ]; then
		FIND=`find /var/spool/cron -type f`
		for FILE in $FIND; do
			mv -f $FILE $FILE.orig
			USER=`basename $FILE`
			chown crontab:crontab $FILE.orig
			chmod 640 $FILE.orig
			(test ! -z "$USER" && fcrontab -u $USER -z) > /dev/null 2>&1
		done
		if [ -f /var/spool/cron/root.orig ]; then
			chmod 600 /var/spool/cron/root.orig
			chown root:root /var/spool/cron/root.orig
		fi
	fi
fi

if [ "$1" = "2" ]; then
	FIND=`find /var/spool/cron -name \*.orig`
	for FILE in $FIND; do
		BASENAME=`basename $FILE`
		USER=`echo "$BASENAME"| sed 's/.orig//'`
		[ ! -z "$USER" ] && fcrontab -u $USER -z > /dev/null 2>&1
	done
fi

/sbin/chkconfig --add crond
%service crond restart "Cron Daemon"

umask 027
touch /var/log/cron
chgrp crontab /var/log/cron
chmod 660 /var/log/cron

%preun
if [ "$1" = "0" ]; then
	%service crond stop
	/sbin/chkconfig --del crond

	rm -f /var/spool/cron/systab*

	FIND=`find /var/spool/cron -name '*.orig'`
	for FILE in $FIND; do
		BASENAME=`basename $FILE`
		USER="${BASENAME%.orig}"
		mv -f $FILE /var/spool/cron/$USER >/dev/null 2>&1
		chown $USER:crontab /var/spool/cron/$USER >/dev/null 2>&1
		chmod 600 /var/spool/cron/$USER >/dev/null 2>&1
	done
	rm -f /var/spool/cron/rm.*
	rm -f /var/spool/cron/fcrontab.sig
	rm -f /var/spool/cron/new.*
fi

%postun
if [ "$1" = "0" ]; then
	%userremove crontab
	%groupremove crontab
fi

%triggerpostun -- hc-cron
# reinstall crond init.d links, which could be different
/sbin/chkconfig --del crond
/sbin/chkconfig --add crond

%files
%defattr(644,root,root,755)
%doc doc/en/HTML doc/en/txt/{faq.txt,changes.txt,readme.txt,thanks.txt,todo.txt}
%attr(750,root,crontab) %dir %{_sysconfdir}/cron*
%attr(750,root,root) %{_sysconfdir}/cron.hourly/%{name}.systab
%attr(640,root,crontab) %config(noreplace) /etc/cron.d/crontab
%attr(640,root,crontab) %config(noreplace,missingok) %verify(not md5 mtime size) %{_sysconfdir}/cron/cron.allow
%attr(640,root,crontab) %config(noreplace,missingok) %verify(not md5 mtime size) %{_sysconfdir}/cron/cron.deny
%attr(640,root,root) %config(noreplace) %verify(not md5 mtime size) /etc/sysconfig/cron
%attr(644,root,crontab) %config(noreplace) %verify(not md5 mtime size) /etc/pam.d/fcron
%attr(644,root,crontab) %config(noreplace) %verify(not md5 mtime size) /etc/pam.d/fcrontab
%attr(754,root,root) /etc/rc.d/init.d/crond
%config(noreplace) %verify(not md5 mtime size) %attr(640,root,root) /etc/logrotate.d/cron
%config(noreplace) %verify(not md5 mtime size) %{_sysconfdir}/fcron.*
%attr(640,root,crontab) %config(noreplace) %{_sysconfdir}/fcron.conf
%attr(755,root,root) %{_sbindir}/crond
%attr(6111,crontab,crontab) %{_bindir}/fcrontab
%attr(6111,crontab,crontab) %{_bindir}/crontab
%attr(4711,root,root) %{_bindir}/fcronsighup
%attr(6111,crontab,crontab) %{_bindir}/fcrondyn
%{_mandir}/man1/fcrondyn.1*
%{_mandir}/man1/fcrontab.1*
%{_mandir}/man3/bitstring.3*
%{_mandir}/man5/fcron.conf.5*
%{_mandir}/man5/fcrontab.5*
%{_mandir}/man8/fcron.8*
%lang(fr) %{_mandir}/fr/man1/fcrondyn.1*
%lang(fr) %{_mandir}/fr/man1/fcrontab.1*
%lang(fr) %{_mandir}/fr/man3/bitstring.3*
%lang(fr) %{_mandir}/fr/man5/fcron.conf.5*
%lang(fr) %{_mandir}/fr/man5/fcrontab.5*
%lang(fr) %{_mandir}/fr/man8/fcron.8*
%attr(1730,root,crontab) /var/spool/cron
%attr(660,root,crontab) %ghost /var/log/cron

%define date	%(echo `LC_ALL="C" date +"%a %b %d %Y"`)
%changelog
* %{date} PLD Team <feedback@pld-linux.org>
All persons listed below can be reached at <cvs_login>@pld-linux.org

$Log: fcron.spec,v $
Revision 1.57  2010/04/06 11:24:56  lisu
- 3.0.6

Revision 1.56  2010/03/18 07:43:21  lisu
- back to /bin/vi as default editor
- rel 2

Revision 1.55  2010/03/17 13:22:07  glen
- # is not "comment" in .spec, when that be learned?

Revision 1.54  2010/03/17 11:49:09  lisu
- up to 3.0.5
- use vim as default editor

Revision 1.53  2008/06/25 22:11:35  arekm
- rel 3; relax conf permissions

Revision 1.52  2008-02-09 12:50:58  qboosh
- cleanup

Revision 1.51  2008-02-06 20:13:11  glen
- never use '<=' in trigger comparision (well just drop old triggers); rel 2

Revision 1.50  2008-01-12 16:24:20  qboosh
- removed mail_output_only_if_there_is_output patch

Revision 1.49  2008-01-12 16:11:27  qboosh
- use install-staged to disable stripping
  (with a side-effect of fixing parallel make)

Revision 1.48  2008-01-12 16:04:14  qboosh
- equal-versioned crontabs Provides
- yumoconflicts replaced by virtual package Obsoletes (already provided crondaemon)

Revision 1.47  2007-11-10 23:04:03  lisu
- up to 3.0.4 version
- TODO

Revision 1.46  2007/11/09 18:11:10  patrys
- fixing the world continued
- mutual conflicts instead of obsoletes
- rel up
- STBR

Revision 1.45  2007-06-18 18:33:48  lisu
- License changet to GPL v2+

Revision 1.44  2007/06/18 18:13:38  lisu
- 3.0.3
- new patch
- only DESTDIR path in needed

Revision 1.43  2007/02/12 21:23:55  glen
- tabs in preamble

Revision 1.42  2007/02/12 00:48:49  baggins
- converted to UTF-8

Revision 1.41  2007/01/21 23:58:35  qboosh
- pass --with-editor

Revision 1.40  2007/01/19 13:00:16  lisu
- 3.0.2
- TODO added

Revision 1.39  2006/09/21 19:20:13  undefine
- up to 3.0.1 by lisu87@gmail.com

Revision 1.38  2006/09/15 19:04:18  qboosh
- don't assume man compression

Revision 1.37  2006/09/09 01:21:40  glen
- rel 4 (rebuild with fixed %useradd/%groupadd macros)

Revision 1.36  2006/08/12 09:28:43  ankry
- formatting

Revision 1.35  2006/04/14 14:40:34  glen
- rel 3

Revision 1.34  2006/02/27 23:11:29  glen
- use %service, cosmetics

Revision 1.33  2006/01/23 12:56:52  arekm
- rel 2; force sendmail path

Revision 1.32  2006/01/23 12:51:09  arekm
- force sendmail path

Revision 1.31  2005/12/12 16:24:19  glen
- adapterized (sorted %verify attrs)

Revision 1.30  2005/12/04 22:58:06  glen
- adapterized (sorted %verify flags)

Revision 1.29  2005/09/09 22:51:54  arekm
- up to 3.0.0

Revision 1.28  2005/07/30 10:26:21  arekm
- up to 2.9.7

Revision 1.27  2005/05/01 17:31:30  glen
- use %useradd/%groupadd macros

Revision 1.26  2005/03/13 20:20:14  kolodko
- up to 2.6.9, not tested

Revision 1.25  2005/01/08 16:26:54  arekm
- rel 1; don't mail output if there isn't any

Revision 1.24  2004/12/29 13:46:47  kolodko
- added fcron.systab in /etc/cron.hourly/
- rel 0.2

Revision 1.23  2004/12/26 18:57:24  kolodko
- option --with-sysfcrontab needs NAME of (virtual) user, use standart "systab"

Revision 1.22  2004/12/26 15:01:07  arekm
- add --with-sysfcrontab=/etc/cron.d/crontab option

Revision 1.21  2004/12/12 09:33:23  adamg
- updated to 2.9.5.1

Revision 1.20  2004/11/07 16:07:52  ankry
- removed O: crondaemon

Revision 1.19  2004/10/16 06:26:48  paladine
- spelling fix

Revision 1.18  2004/10/10 10:55:52  kolodko
- clean up
- polish man pages isn't good idea
- rel 0.5

Revision 1.17  2004/10/09 20:29:49  kolodko
- cosmetic

Revision 1.16  2004/10/09 20:16:24  kolodko
- some cosmetics
- rel 0.4

Revision 1.15  2004/09/28 14:58:03  kolodko
- typo + cosmetics

Revision 1.14  2004/09/23 09:50:26  kolodko
- strict macros in logrotate.d

Revision 1.13  2004/09/17 12:24:20  kolodko
- corrected syntax

Revision 1.12  2004/09/16 21:56:49  kolodko
- added more %post(), %pre()
- added user crontab, uid 134
- added TODO
- rel 0.3
- ready to tests

Revision 1.11  2004/09/15 15:49:43  kolodko
- more changes in %post

Revision 1.10  2004/09/14 01:03:28  kolodko
- corrected %post
- back to user crontab
- NFY

Revision 1.9  2004/09/11 16:13:04  kolodko
- added %doc

Revision 1.8  2004/09/11 15:26:44  kolodko
- added scripts in preun, post for compatible with other crons
- added some missing files
- added fcron.conf, fcrontab.conf
- change usrname to root

Revision 1.7  2004/09/04 11:34:35  arekm
- updated

Revision 1.6  2004/08/17 22:45:44  ankry
- added proper BR: rpmbuild(macros)

Revision 1.5  2004/08/17 21:34:34  ankry
- use user/group macros

Revision 1.4  2004/08/09 15:26:40  ankry
- rel. down to 0.1; it's unfinished: missing sources

Revision 1.3  2004/03/12 18:07:38  qboosh
- cosmetics

Revision 1.2  2004/03/12 14:30:35  ankry
- pl

Revision 1.1  2004/03/12 12:29:04  arekm
- raw
